<?php
/**
 * Created by PhpStorm.
 * User: FrédéricGuichard
 * Date: 21/09/2016
 * Time: 17:11
 */

namespace ByDedi\AdminBundle\Form\Type;

use A2lix\TranslationFormBundle\Form\Type\TranslationsType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolver;

class TranslatableType extends TranslationsType
{
    /**
     *
     * @param \Symfony\Component\Form\FormBuilderInterface $builder
     * @param array $options
     */
    public function buildForm(FormBuilderInterface $builder, array $options)
    {
        $translatableProperties = [];
        if ($builder->getAttribute('sonata_admin') !== null) {
            $sonataAdmin = $builder->getAttribute('sonata_admin')['admin'];

            $translationClass = $sonataAdmin->getClass() . 'Translation';
            if (class_exists($translationClass)) {
                $reflection = new \ReflectionClass(new $translationClass);
                $props = $reflection->getProperties();
                foreach ($props as $p) {
                    $translatableProperties[] = $p->name;
                }
            }
        }
        $options['label'] = false;
        $options['exclude_fields'] = array_diff($translatableProperties, array_keys($options['fields']));
        $reflectionClassConfig = new \ReflectionClass($builder);
        $parentConfigClass = $reflectionClassConfig->getParentClass();
        $property = $parentConfigClass->getProperty('options');
        $property->setAccessible(true);
        $property->setValue($builder, $options);
        parent::buildForm($builder, $options);
    }

    public function configureOptions(OptionsResolver $resolver)
    {
        parent::configureOptions($resolver);
        $resolver->setDefaults([
            'property_path' => 'translations',
            'label' => false,
        ]);
    }

}
